(* Source code for DB application used in the RED Demo. RED specific
  code is identified by <RED:>
*)
unit Dt2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  StdCtrls, Forms, DBCtrls, DB, Buttons, DBTables, Mask, ExtCtrls, Dialogs,
  Dblnk;

type
  TForm2 = class(TForm)
    ScrollBox: TScrollBox;
    Label1: TLabel;
    EditUser: TDBEdit;
    Label2: TLabel;
    EditSequence: TDBEdit;
    Label3: TLabel;
    EditPrice: TDBEdit;
    Label4: TLabel;
    EditComment: TDBEdit;
    DBNavigator: TDBNavigator;
    Panel1: TPanel;
    DataSource1: TDataSource;
    Panel2: TPanel;
    Table1: TTable;
    Table1User: TStringField;
    Table1Sequence: TIntegerField;
    Table1Price: TCurrencyField;
    Table1Comment: TStringField;
    Table1Photo: TGraphicField;
    DBImage1: TDBImage;
    grfButton: TBitBtn;
    GrpLoader: TOpenDialog;
    tLnkManager1: tLnkManager;    (* RED Component *)
    tDataRecorder1: tDataRecorder;(* RED Component *)
    procedure FormCreate(Sender: TObject);
    procedure DBImage1Click(Sender: TObject);
    procedure tLnkManager1DermineLocation(Sender: TObject);
    procedure Table1NewRecord(DataSet: TDataset);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { private declarations }
  public
   SeqNo:LongInt;
    { public declarations }
  end;

var
  Form2: TForm2;

implementation
Uses UsrPref; (* RED Unit. gUserId is a global variable : current user id *)
{$R *.DFM}
Type
 tOurNav=class(TDBNavigator)
 (* To gain access to the Buttons protected variable of tDBNavigator *)
 end;

procedure TForm2.FormCreate(Sender: TObject);
Var S:String[13];
begin
 Table1.Open;
 (* Show current location & Data path *)
 If tLnkManager1.Location=at_Host
  then S:=' [Host]'
  else S:=' [Remote]';
 Caption:=Table1.DataBaseName+'\'+Table1.TableName+S;
 (* RED: Get next Sequence for current user. Set SeqNo to next sequence value *)
 With Table1 do begin
  SetRange([gUSerId],[gUserId]);
  Last;
  SeqNo:=Table1.Fields[1].AsInteger+1;
  SetRange([Nil],[Nil]);
 end;
end;

procedure TForm2.DBImage1Click(Sender: TObject);
begin (* Select graphic to use for this record. Not RED code *)
 If GrpLoader.Execute
  then Begin
   If Table1.RecordCount=0
    then Table1.Insert
    else If Table1.State=dsBrowse
          then Table1.Edit;
   Table1photo.LoadFromFile(grpLoader.Filename);
  end;
end;

procedure TForm2.tLnkManager1DermineLocation(Sender: TObject);
begin (* RED: Run time location setting *)
 If ParamCount=2
  then tLnkManager1.Domain:=StrToInt(ParamStr(2));
 If ParamCount<>0
  then Case ParamStr(1)[1] of
   'H','h':tLnkManager1.Location:=at_Host;
   'R','r':tLnkManager1.Location:=at_remote;
  end
  else tLnkManager1.Location:=at_remote;
end;

procedure TForm2.Table1NewRecord(DataSet: TDataset);
begin(* RED: Make sure we have a system wide unique index *)
 Table1.Fields[0].AsString:=gUserId;
 Table1.Fields[1].AsInteger:=SeqNo;
 Inc(SeqNo);
end;

(* The next method is not RED code. It's just to make sure
  that the modifications have been posted.  *)
procedure TForm2.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 If tOurNav(DBNavigator).Buttons[nbPost].Enabled
  then CanClose:=MessageDlg('Last modifications have not been posted. Quit anyway?',
                            mtConfirmation,[mbYes,MbNo],0)=mrYes
  else CanClose:=True;
end;

end.
