unit QCard;

interface

uses
  WinTypes;

{ Constants to use in your game --------------------------}

const
  CARDWIDTH = 71;
  CARDHEIGHT = 96;
  OFFSET = 16;

{ declarations for functions -----------------------------}

procedure DrawSymbol(hWindow: hWnd; Value1, Value2, Value3: Integer);
procedure DrawCard(hWindow: hWnd; Value1, Value2, Value3: Integer);
procedure DrawBack(hWindow: hWnd; Value1, Value2, Value3: Integer);
procedure RemoveCard(hWindow: hWnd; Value1: Integer);
function InitializeDeck(hWindow: HWND): Boolean;
procedure DealCard(hWindow: hWnd; Value1, Value2, Value3: Integer);
function GetCardColor(Value: Integer): Integer;
function GetCardSuit(Value: Integer): Integer;
function GetCardValue(Value: Integer): Integer;
function IsCardVisible(Value: Integer): Boolean;
function GetCardBlocked(Value: Integer): Boolean;
function IsCardDisabled(Value: Integer): Boolean;
function GetCardX(Value: Integer): Integer;
function GetCardY(Value: Integer): Integer;
function GetUser1(Value: Integer): Boolean;
function GetUser2(Value: Integer): Integer;
function GetUser3(Value: Integer): Integer;
function GetUser4(Value: InTeger): Integer;
procedure SetCardVisible(Value1: Integer; Bool1: Boolean);
procedure AdjustCardBlocked(Value1: Integer; Bool1: Boolean);
procedure SetCardDisabled(Value1: Integer; Bool1: Boolean);
procedure SetCardX(Value1, Value2: Integer);
procedure SetCardY(Value1, Value2: Integer);
procedure SetUser1(Value1: Integer; Bool1: Boolean);
procedure SetUser2(Value1, Value2: Integer);
procedure SetUser3(Value1, Value2: Integer);
procedure SetUser4(Value1, Value2: Integer);
function InitDrag(hWindow: hWnd; Value1, Value2: Integer): Integer;
procedure AbortDrag;
procedure DoDrag(hWindow: hWnd; Value1, Value2: Integer);
function EndDrag(hWindow: hWnd; Value1, Value2: Integer): Integer;
procedure ReturnDrag(hWindow: hWnd; Value1, Value2, Value3: Integer);
procedure SetDefaultValues;
procedure BlockDrag(hWindow: hWnd; var A: Integer; Value1, Value2, Value3: Integer);
function EndBlockDrag(hWindow: hWnd; var A: Integer; Value1, Value2, Value3: Integer): Integer;
procedure ReturnBlockDrag(hWindow: hWnd; var A: Integer; Value1, Value2, Value3: Integer);
function GetFreeDestination(Value: Integer): Integer;
procedure SetCurrentBack(Value: Integer);

{ Undocumented functions, generally not used ------------}

{ returns the number of any unblocked card which lies beneath the point int(x), int(y) }
function PointInFreeCard(Value1, Value2: Integer): Integer;

{ returns the number of any card whose top 16 pixels lie beneath the point int(x), int(y) }
function PointInCardTop(Value1, Value2: Integer): Integer;

{ manually sets the active drag card for a subsequent DoDrag or BlockDrag call }
procedure SetActiveCard(Value: Integer);

implementation

procedure DrawSymbol; external 'QCARD';
procedure DrawCard; external 'QCARD';
procedure DrawBack; external 'QCARD';
procedure RemoveCard; external 'QCARD';
function InitializeDeck; external 'QCARD';
procedure DealCard; external 'QCARD';
function GetCardColor; external 'QCARD';
function GetCardSuit; external 'QCARD';
function GetCardValue; external 'QCARD';
function IsCardVisible; external 'QCARD';
function GetCardBlocked; external 'QCARD';
function IsCardDisabled; external 'QCARD';
function GetCardX; external 'QCARD';
function GetCardY; external 'QCARD';
function GetUser1; external 'QCARD';
function GetUser2; external 'QCARD';
function GetUser3; external 'QCARD';
function GetUser4; external 'QCARD';
procedure SetCardVisible; external 'QCARD';
procedure AdjustCardBlocked; external 'QCARD';
procedure SetCardDisabled; external 'QCARD';
procedure SetCardX; external 'QCARD';
procedure SetCardY; external 'QCARD';
procedure SetUser1; external 'QCARD';
procedure SetUser2; external 'QCARD';
procedure SetUser3; external 'QCARD';
procedure SetUser4; external 'QCARD';
function InitDrag; external 'QCARD' index 29;
procedure AbortDrag; external 'QCARD';
procedure DoDrag; external 'QCARD';
function EndDrag; external 'QCARD';
procedure ReturnDrag; external 'QCARD';
procedure SetDefaultValues; external 'QCARD';
procedure BlockDrag; external 'QCARD';
function EndBlockDrag; external 'QCARD';
procedure ReturnBlockDrag; external 'QCARD';
function GetFreeDestination; external 'QCARD';
procedure SetCurrentBack; external 'QCARD';
function PointInFreeCard; external 'QCARD';
function PointInCardTop; external 'QCARD';
procedure SetActiveCard; external 'QCARD';

end.











